/* A silly little calculator implemented in Rexx using
   Java components for the UI. 2001-05-02, 2003-01-23, ---rgf
   ("bsf\samples\bsh\calculator.js" served as an example)       */

if rxFuncQuery("BSF") then  /* no bsf4rexx support available yet, hence load Java */
do
   call rxFuncAdd "BsfLoadFuncs", "BSF4Rexx", "BsfLoadFuncs"
   call BsfLoadFuncs    /* load all BSF-functions                    */
   call BsfLoadJava     /* load the JVM and set up BSF4Rexx-support  */
end

if      BsfInvokedBy()=1 then say "This Rexx program was invoked by Java!"
else if BsfInvokedBy()=2 then say "This Rexx program was invoked by Rexx, JVM loaded by Rexx!"
else                          say "No JVM present, we got troubles ..."


f =  bsf("registerBean", "", "java.awt.Frame", "string", "BSH Calculator")
call bsf "addEventListener", f, "window", "windowClosing", "call bsf 'exit'"

f1 = bsf("registerBean", "", "java.awt.TextField", "int", 20)
call bsf "addEventListener", f1, "action", "", "call doMath /*action*/"

f2 = bsf("registerBean", "", "java.awt.TextField", "int", 20)
call bsf "addEventListener", f2, "text", "", "call doMath /*text*/"

p  = bsf("registerBean", "", "java.awt.Panel")
call bsf "invoke", p, "setLayout", "obj", bsf("registerBean", "", "java.awt.GridLayout", "int", 2, "int", 2)

call bsf "invoke", p, "add", "obj", bsf("registerBean", "", "java.awt.Label", "str", "Enter Operand")
call bsf "invoke", p, "add", "obj", f1

call bsf "invoke", p, "add", "obj", bsf("registerBean", "", "java.awt.Label", "str", "Enter Operand")
call bsf "invoke", p, "add", "obj", f2

call bsf "invoke", f, "add", "str", "North", "obj", p
call bsf "invoke", f, "add", "str", "Center", "obj", bsf("registerBean", "", "java.awt.Label", "str", "Results:")


p =  bsf("registerBean", "", "java.awt.Panel")
call bsf "invoke", p, "setLayout", "obj", bsf("registerBean", "", "java.awt.GridLayout", "int", 4, "int", 2)

call bsf "invoke", p, "add", "obj", bsf("registerBean", "", "java.awt.Label", "str", "Sum")
sum = bsf("registerBean", "", "java.awt.TextField", "int", 20)
call bsf "invoke", p, "add", "obj", sum

call bsf "invoke", p, "add", "obj", bsf("registerBean", "", "java.awt.Label", "str", "Difference")
diff= bsf("registerBean", "", "java.awt.TextField", "int", 20)
call bsf "invoke", p, "add", "obj", diff

call bsf "invoke", p, "add", "obj", bsf("registerBean", "", "java.awt.Label", "str", "Product")
prod= bsf("registerBean", "", "java.awt.TextField", "int", 20)
call bsf "invoke", p, "add", "obj", prod

call bsf "invoke", p, "add", "obj", bsf("registerBean", "", "java.awt.Label", "str", "Quotient")
quo = bsf("registerBean", "", "java.awt.TextField", "int", 20)
call bsf "invoke", p, "add", "obj", quo

call bsf "invoke", f, "add", "str", "South", "obj", p

call bsf "invoke", f, "pack"
call bsf "invoke", f, "show"
call bsf "invoke", f, "toFront"

do forever
   a=bsf("pollEventText")
   say "... received: ["a"]"
   interpret a
end
exit

getField: procedure
   parse arg f
   t=bsf("invoke", f, "getText")
   if t="" then return 0
   return t

doMath:
   n1 = getField(f1); if n1="-" then n1=-1;else if n1="+" then n1=1
   n2 = getField(f2); if n2="-" then n2=-1;else if n2="+" then n2=1
   call bsf "invoke", sum, "setText", "str", n1+n2
   call bsf "invoke", diff,"setText", "str", n1-n2
   call bsf "invoke", prod,"setText", "str", n1*n2
   if n2 = 0 then call bsf "invoke", quo, "setText", "str", "DIVISION by 0 !!"
             else call bsf "invoke", quo, "setText", "str", n1/n2
   return

